package org.jamon.node;

import java.util.ArrayList;
import java.util.List;

import org.jamon.api.Location;
public class AbsMethodNode extends AbstractNode
{
  public AbsMethodNode(Location p_location, String p_name)
  {
    super(p_location);
    if ((m_name = p_name) == null)
      { throw new NullPointerException(); }
  }

  @Override public void apply(Analysis p_analysis)
  {
    p_analysis.caseAbsMethodNode(this);
  }

  private final String m_name;
  public String getName() { return m_name; }

  private final List<AbstractArgsNode> m_argsBlocks = new ArrayList<AbstractArgsNode>();
  public AbsMethodNode addArgsBlock(AbstractArgsNode p_argsBlock)
  {
    if (p_argsBlock == null) { throw new NullPointerException(); }
    m_argsBlocks.add(p_argsBlock);
    return this;
  }
  public List<AbstractArgsNode> getArgsBlocks() { return m_argsBlocks; }

  @Override public boolean equals(Object p_obj)
  {
    return p_obj != null
        && super.equals(p_obj)
      && m_name.equals(((AbsMethodNode) p_obj).m_name)
      && m_argsBlocks.equals(((AbsMethodNode) p_obj).m_argsBlocks)
    ;
  }

  @Override public int hashCode()
  {
    return super.hashCode()
      ^ m_name.hashCode()
      ^ m_argsBlocks.hashCode()
    ;
  }

  @Override protected void propertiesToString(StringBuilder p_buffer)
  {
    super.propertiesToString(p_buffer);
    addProperty(p_buffer, "name", m_name);
    addPropertyList(p_buffer, "argsBlock", m_argsBlocks);
  }

}
