package org.jamon.node;

import java.util.ArrayList;
import java.util.List;

import org.jamon.api.Location;
public class AbstractArgsNode extends AbstractNode
{
  public AbstractArgsNode(Location p_location)
  {
    super(p_location);
  }

  @Override public void apply(Analysis p_analysis)
  {
    p_analysis.caseAbstractArgsNode(this);
  }

  private final List<ArgNode> m_args = new ArrayList<ArgNode>();
  public AbstractArgsNode addArg(ArgNode p_arg)
  {
    if (p_arg == null) { throw new NullPointerException(); }
    m_args.add(p_arg);
    return this;
  }
  public List<ArgNode> getArgs() { return m_args; }

  @Override public boolean equals(Object p_obj)
  {
    return p_obj != null
        && super.equals(p_obj)
      && m_args.equals(((AbstractArgsNode) p_obj).m_args)
    ;
  }

  @Override public int hashCode()
  {
    return super.hashCode()
      ^ m_args.hashCode()
    ;
  }

  @Override protected void propertiesToString(StringBuilder p_buffer)
  {
    super.propertiesToString(p_buffer);
    addPropertyList(p_buffer, "arg", m_args);
  }

}
