package org.jamon.node;

import java.util.ArrayList;
import java.util.List;

import org.jamon.api.Location;
public class AliasesNode extends AbstractNode
{
  public AliasesNode(Location p_location)
  {
    super(p_location);
  }

  @Override public void apply(Analysis p_analysis)
  {
    p_analysis.caseAliasesNode(this);
  }

  private final List<AliasDefNode> m_aliass = new ArrayList<AliasDefNode>();
  public AliasesNode addAlias(AliasDefNode p_alias)
  {
    if (p_alias == null) { throw new NullPointerException(); }
    m_aliass.add(p_alias);
    return this;
  }
  public List<AliasDefNode> getAliass() { return m_aliass; }

  @Override public boolean equals(Object p_obj)
  {
    return p_obj != null
        && super.equals(p_obj)
      && m_aliass.equals(((AliasesNode) p_obj).m_aliass)
    ;
  }

  @Override public int hashCode()
  {
    return super.hashCode()
      ^ m_aliass.hashCode()
    ;
  }

  @Override protected void propertiesToString(StringBuilder p_buffer)
  {
    super.propertiesToString(p_buffer);
    addPropertyList(p_buffer, "alias", m_aliass);
  }

}
