package org.jamon.node;
public class DepthFirstAnalysisAdapter implements Analysis
{
  public void inRootAliasPathNode(@SuppressWarnings("unused") RootAliasPathNode p_node) {}
  public void outRootAliasPathNode(@SuppressWarnings("unused") RootAliasPathNode p_node) {}
  public void caseRootAliasPathNode(RootAliasPathNode p_node)
  {
    inRootAliasPathNode(p_node);
    for (AbstractNode node : p_node.getPathElements())
    {
      node.apply(this);
    }
    outRootAliasPathNode(p_node);
  }

  public void inMultiFragmentCallNode(@SuppressWarnings("unused") MultiFragmentCallNode p_node) {}
  public void outMultiFragmentCallNode(@SuppressWarnings("unused") MultiFragmentCallNode p_node) {}
  public void caseMultiFragmentCallNode(MultiFragmentCallNode p_node)
  {
    inMultiFragmentCallNode(p_node);
    p_node.getCallPath().apply(this);
    for (AbstractNode node : p_node.getGenericParams())
    {
      node.apply(this);
    }
    p_node.getParams().apply(this);
    for (AbstractNode node : p_node.getFragments())
    {
      node.apply(this);
    }
    outMultiFragmentCallNode(p_node);
  }

  public void inParamNameNode(@SuppressWarnings("unused") ParamNameNode p_node) {}
  public void outParamNameNode(@SuppressWarnings("unused") ParamNameNode p_node) {}
  public void caseParamNameNode(ParamNameNode p_node)
  {
    inParamNameNode(p_node);
    outParamNameNode(p_node);
  }

  public void inParentArgWithDefaultNode(@SuppressWarnings("unused") ParentArgWithDefaultNode p_node) {}
  public void outParentArgWithDefaultNode(@SuppressWarnings("unused") ParentArgWithDefaultNode p_node) {}
  public void caseParentArgWithDefaultNode(ParentArgWithDefaultNode p_node)
  {
    inParentArgWithDefaultNode(p_node);
    p_node.getName().apply(this);
    p_node.getValue().apply(this);
    outParentArgWithDefaultNode(p_node);
  }

  public void inMethodNode(@SuppressWarnings("unused") MethodNode p_node) {}
  public void outMethodNode(@SuppressWarnings("unused") MethodNode p_node) {}
  public void caseMethodNode(MethodNode p_node)
  {
    inMethodNode(p_node);
    for (AbstractNode node : p_node.getSubNodes())
    {
      node.apply(this);
    }
    outMethodNode(p_node);
  }

  public void inGenericsParamNode(@SuppressWarnings("unused") GenericsParamNode p_node) {}
  public void outGenericsParamNode(@SuppressWarnings("unused") GenericsParamNode p_node) {}
  public void caseGenericsParamNode(GenericsParamNode p_node)
  {
    inGenericsParamNode(p_node);
    for (AbstractNode node : p_node.getBounds())
    {
      node.apply(this);
    }
    outGenericsParamNode(p_node);
  }

  public void inExtendsNode(@SuppressWarnings("unused") ExtendsNode p_node) {}
  public void outExtendsNode(@SuppressWarnings("unused") ExtendsNode p_node) {}
  public void caseExtendsNode(ExtendsNode p_node)
  {
    inExtendsNode(p_node);
    p_node.getPath().apply(this);
    outExtendsNode(p_node);
  }

  public void inArgValueNode(@SuppressWarnings("unused") ArgValueNode p_node) {}
  public void outArgValueNode(@SuppressWarnings("unused") ArgValueNode p_node) {}
  public void caseArgValueNode(ArgValueNode p_node)
  {
    inArgValueNode(p_node);
    outArgValueNode(p_node);
  }

  public void inEscapeNode(@SuppressWarnings("unused") EscapeNode p_node) {}
  public void outEscapeNode(@SuppressWarnings("unused") EscapeNode p_node) {}
  public void caseEscapeNode(EscapeNode p_node)
  {
    inEscapeNode(p_node);
    outEscapeNode(p_node);
  }

  public void inElseIfNode(@SuppressWarnings("unused") ElseIfNode p_node) {}
  public void outElseIfNode(@SuppressWarnings("unused") ElseIfNode p_node) {}
  public void caseElseIfNode(ElseIfNode p_node)
  {
    inElseIfNode(p_node);
    for (AbstractNode node : p_node.getSubNodes())
    {
      node.apply(this);
    }
    outElseIfNode(p_node);
  }

  public void inAbstractCallNode(@SuppressWarnings("unused") AbstractCallNode p_node) {}
  public void outAbstractCallNode(@SuppressWarnings("unused") AbstractCallNode p_node) {}
  public void caseAbstractCallNode(AbstractCallNode p_node)
  {
    inAbstractCallNode(p_node);
    outAbstractCallNode(p_node);
  }

  public void inAbstractEscapeNode(@SuppressWarnings("unused") AbstractEscapeNode p_node) {}
  public void outAbstractEscapeNode(@SuppressWarnings("unused") AbstractEscapeNode p_node) {}
  public void caseAbstractEscapeNode(AbstractEscapeNode p_node)
  {
    inAbstractEscapeNode(p_node);
    outAbstractEscapeNode(p_node);
  }

  public void inNoParamsNode(@SuppressWarnings("unused") NoParamsNode p_node) {}
  public void outNoParamsNode(@SuppressWarnings("unused") NoParamsNode p_node) {}
  public void caseNoParamsNode(NoParamsNode p_node)
  {
    inNoParamsNode(p_node);
    outNoParamsNode(p_node);
  }

  public void inGenericsBoundNode(@SuppressWarnings("unused") GenericsBoundNode p_node) {}
  public void outGenericsBoundNode(@SuppressWarnings("unused") GenericsBoundNode p_node) {}
  public void caseGenericsBoundNode(GenericsBoundNode p_node)
  {
    inGenericsBoundNode(p_node);
    outGenericsBoundNode(p_node);
  }

  public void inSubcomponentNode(@SuppressWarnings("unused") SubcomponentNode p_node) {}
  public void outSubcomponentNode(@SuppressWarnings("unused") SubcomponentNode p_node) {}
  public void caseSubcomponentNode(SubcomponentNode p_node)
  {
    inSubcomponentNode(p_node);
    for (AbstractNode node : p_node.getSubNodes())
    {
      node.apply(this);
    }
    outSubcomponentNode(p_node);
  }

  public void inRelativePathNode(@SuppressWarnings("unused") RelativePathNode p_node) {}
  public void outRelativePathNode(@SuppressWarnings("unused") RelativePathNode p_node) {}
  public void caseRelativePathNode(RelativePathNode p_node)
  {
    inRelativePathNode(p_node);
    for (AbstractNode node : p_node.getPathElements())
    {
      node.apply(this);
    }
    outRelativePathNode(p_node);
  }

  public void inParentArgNode(@SuppressWarnings("unused") ParentArgNode p_node) {}
  public void outParentArgNode(@SuppressWarnings("unused") ParentArgNode p_node) {}
  public void caseParentArgNode(ParentArgNode p_node)
  {
    inParentArgNode(p_node);
    p_node.getName().apply(this);
    outParentArgNode(p_node);
  }

  public void inOptionalArgNode(@SuppressWarnings("unused") OptionalArgNode p_node) {}
  public void outOptionalArgNode(@SuppressWarnings("unused") OptionalArgNode p_node) {}
  public void caseOptionalArgNode(OptionalArgNode p_node)
  {
    inOptionalArgNode(p_node);
    p_node.getType().apply(this);
    p_node.getName().apply(this);
    p_node.getValue().apply(this);
    outOptionalArgNode(p_node);
  }

  public void inAbstractImportNode(@SuppressWarnings("unused") AbstractImportNode p_node) {}
  public void outAbstractImportNode(@SuppressWarnings("unused") AbstractImportNode p_node) {}
  public void caseAbstractImportNode(AbstractImportNode p_node)
  {
    inAbstractImportNode(p_node);
    outAbstractImportNode(p_node);
  }

  public void inLiteralNode(@SuppressWarnings("unused") LiteralNode p_node) {}
  public void outLiteralNode(@SuppressWarnings("unused") LiteralNode p_node) {}
  public void caseLiteralNode(LiteralNode p_node)
  {
    inLiteralNode(p_node);
    outLiteralNode(p_node);
  }

  public void inDocNode(@SuppressWarnings("unused") DocNode p_node) {}
  public void outDocNode(@SuppressWarnings("unused") DocNode p_node) {}
  public void caseDocNode(DocNode p_node)
  {
    inDocNode(p_node);
    outDocNode(p_node);
  }

  public void inSimpleCallNode(@SuppressWarnings("unused") SimpleCallNode p_node) {}
  public void outSimpleCallNode(@SuppressWarnings("unused") SimpleCallNode p_node) {}
  public void caseSimpleCallNode(SimpleCallNode p_node)
  {
    inSimpleCallNode(p_node);
    p_node.getCallPath().apply(this);
    for (AbstractNode node : p_node.getGenericParams())
    {
      node.apply(this);
    }
    p_node.getParams().apply(this);
    outSimpleCallNode(p_node);
  }

  public void inNamedParamsNode(@SuppressWarnings("unused") NamedParamsNode p_node) {}
  public void outNamedParamsNode(@SuppressWarnings("unused") NamedParamsNode p_node) {}
  public void caseNamedParamsNode(NamedParamsNode p_node)
  {
    inNamedParamsNode(p_node);
    for (AbstractNode node : p_node.getParams())
    {
      node.apply(this);
    }
    outNamedParamsNode(p_node);
  }

  public void inFragmentCallNode(@SuppressWarnings("unused") FragmentCallNode p_node) {}
  public void outFragmentCallNode(@SuppressWarnings("unused") FragmentCallNode p_node) {}
  public void caseFragmentCallNode(FragmentCallNode p_node)
  {
    inFragmentCallNode(p_node);
    p_node.getCallPath().apply(this);
    for (AbstractNode node : p_node.getGenericParams())
    {
      node.apply(this);
    }
    p_node.getParams().apply(this);
    p_node.getFragment().apply(this);
    outFragmentCallNode(p_node);
  }

  public void inAbsMethodNode(@SuppressWarnings("unused") AbsMethodNode p_node) {}
  public void outAbsMethodNode(@SuppressWarnings("unused") AbsMethodNode p_node) {}
  public void caseAbsMethodNode(AbsMethodNode p_node)
  {
    inAbsMethodNode(p_node);
    for (AbstractNode node : p_node.getArgsBlocks())
    {
      node.apply(this);
    }
    outAbsMethodNode(p_node);
  }

  public void inImportsNode(@SuppressWarnings("unused") ImportsNode p_node) {}
  public void outImportsNode(@SuppressWarnings("unused") ImportsNode p_node) {}
  public void caseImportsNode(ImportsNode p_node)
  {
    inImportsNode(p_node);
    for (AbstractNode node : p_node.getImports())
    {
      node.apply(this);
    }
    outImportsNode(p_node);
  }

  public void inUnnamedFragmentNode(@SuppressWarnings("unused") UnnamedFragmentNode p_node) {}
  public void outUnnamedFragmentNode(@SuppressWarnings("unused") UnnamedFragmentNode p_node) {}
  public void caseUnnamedFragmentNode(UnnamedFragmentNode p_node)
  {
    inUnnamedFragmentNode(p_node);
    for (AbstractNode node : p_node.getSubNodes())
    {
      node.apply(this);
    }
    outUnnamedFragmentNode(p_node);
  }

  public void inParentMarkerNode(@SuppressWarnings("unused") ParentMarkerNode p_node) {}
  public void outParentMarkerNode(@SuppressWarnings("unused") ParentMarkerNode p_node) {}
  public void caseParentMarkerNode(ParentMarkerNode p_node)
  {
    inParentMarkerNode(p_node);
    outParentMarkerNode(p_node);
  }

  public void inArgTypeNode(@SuppressWarnings("unused") ArgTypeNode p_node) {}
  public void outArgTypeNode(@SuppressWarnings("unused") ArgTypeNode p_node) {}
  public void caseArgTypeNode(ArgTypeNode p_node)
  {
    inArgTypeNode(p_node);
    outArgTypeNode(p_node);
  }

  public void inEmitNode(@SuppressWarnings("unused") EmitNode p_node) {}
  public void outEmitNode(@SuppressWarnings("unused") EmitNode p_node) {}
  public void caseEmitNode(EmitNode p_node)
  {
    inEmitNode(p_node);
    p_node.getEscaping().apply(this);
    outEmitNode(p_node);
  }

  public void inParentArgsNode(@SuppressWarnings("unused") ParentArgsNode p_node) {}
  public void outParentArgsNode(@SuppressWarnings("unused") ParentArgsNode p_node) {}
  public void caseParentArgsNode(ParentArgsNode p_node)
  {
    inParentArgsNode(p_node);
    for (AbstractNode node : p_node.getArgs())
    {
      node.apply(this);
    }
    outParentArgsNode(p_node);
  }

  public void inDefNode(@SuppressWarnings("unused") DefNode p_node) {}
  public void outDefNode(@SuppressWarnings("unused") DefNode p_node) {}
  public void caseDefNode(DefNode p_node)
  {
    inDefNode(p_node);
    for (AbstractNode node : p_node.getSubNodes())
    {
      node.apply(this);
    }
    outDefNode(p_node);
  }

  public void inClassNode(@SuppressWarnings("unused") ClassNode p_node) {}
  public void outClassNode(@SuppressWarnings("unused") ClassNode p_node) {}
  public void caseClassNode(ClassNode p_node)
  {
    inClassNode(p_node);
    outClassNode(p_node);
  }

  public void inArgsNode(@SuppressWarnings("unused") ArgsNode p_node) {}
  public void outArgsNode(@SuppressWarnings("unused") ArgsNode p_node) {}
  public void caseArgsNode(ArgsNode p_node)
  {
    inArgsNode(p_node);
    for (AbstractNode node : p_node.getArgs())
    {
      node.apply(this);
    }
    outArgsNode(p_node);
  }

  public void inAbstractArgsNode(@SuppressWarnings("unused") AbstractArgsNode p_node) {}
  public void outAbstractArgsNode(@SuppressWarnings("unused") AbstractArgsNode p_node) {}
  public void caseAbstractArgsNode(AbstractArgsNode p_node)
  {
    inAbstractArgsNode(p_node);
    for (AbstractNode node : p_node.getArgs())
    {
      node.apply(this);
    }
    outAbstractArgsNode(p_node);
  }

  public void inTopNode(@SuppressWarnings("unused") TopNode p_node) {}
  public void outTopNode(@SuppressWarnings("unused") TopNode p_node) {}
  public void caseTopNode(TopNode p_node)
  {
    inTopNode(p_node);
    for (AbstractNode node : p_node.getSubNodes())
    {
      node.apply(this);
    }
    outTopNode(p_node);
  }

  public void inAbstractPathElementNode(@SuppressWarnings("unused") AbstractPathElementNode p_node) {}
  public void outAbstractPathElementNode(@SuppressWarnings("unused") AbstractPathElementNode p_node) {}
  public void caseAbstractPathElementNode(AbstractPathElementNode p_node)
  {
    inAbstractPathElementNode(p_node);
    outAbstractPathElementNode(p_node);
  }

  public void inWhileNode(@SuppressWarnings("unused") WhileNode p_node) {}
  public void outWhileNode(@SuppressWarnings("unused") WhileNode p_node) {}
  public void caseWhileNode(WhileNode p_node)
  {
    inWhileNode(p_node);
    for (AbstractNode node : p_node.getSubNodes())
    {
      node.apply(this);
    }
    outWhileNode(p_node);
  }

  public void inArgNameNode(@SuppressWarnings("unused") ArgNameNode p_node) {}
  public void outArgNameNode(@SuppressWarnings("unused") ArgNameNode p_node) {}
  public void caseArgNameNode(ArgNameNode p_node)
  {
    inArgNameNode(p_node);
    outArgNameNode(p_node);
  }

  public void inOverrideNode(@SuppressWarnings("unused") OverrideNode p_node) {}
  public void outOverrideNode(@SuppressWarnings("unused") OverrideNode p_node) {}
  public void caseOverrideNode(OverrideNode p_node)
  {
    inOverrideNode(p_node);
    for (AbstractNode node : p_node.getSubNodes())
    {
      node.apply(this);
    }
    outOverrideNode(p_node);
  }

  public void inIfNode(@SuppressWarnings("unused") IfNode p_node) {}
  public void outIfNode(@SuppressWarnings("unused") IfNode p_node) {}
  public void caseIfNode(IfNode p_node)
  {
    inIfNode(p_node);
    for (AbstractNode node : p_node.getSubNodes())
    {
      node.apply(this);
    }
    outIfNode(p_node);
  }

  public void inAbstractComponentCallNode(@SuppressWarnings("unused") AbstractComponentCallNode p_node) {}
  public void outAbstractComponentCallNode(@SuppressWarnings("unused") AbstractComponentCallNode p_node) {}
  public void caseAbstractComponentCallNode(AbstractComponentCallNode p_node)
  {
    inAbstractComponentCallNode(p_node);
    p_node.getCallPath().apply(this);
    for (AbstractNode node : p_node.getGenericParams())
    {
      node.apply(this);
    }
    p_node.getParams().apply(this);
    outAbstractComponentCallNode(p_node);
  }

  public void inGenericsNode(@SuppressWarnings("unused") GenericsNode p_node) {}
  public void outGenericsNode(@SuppressWarnings("unused") GenericsNode p_node) {}
  public void caseGenericsNode(GenericsNode p_node)
  {
    inGenericsNode(p_node);
    for (AbstractNode node : p_node.getParams())
    {
      node.apply(this);
    }
    outGenericsNode(p_node);
  }

  public void inParamValueNode(@SuppressWarnings("unused") ParamValueNode p_node) {}
  public void outParamValueNode(@SuppressWarnings("unused") ParamValueNode p_node) {}
  public void caseParamValueNode(ParamValueNode p_node)
  {
    inParamValueNode(p_node);
    outParamValueNode(p_node);
  }

  public void inForNode(@SuppressWarnings("unused") ForNode p_node) {}
  public void outForNode(@SuppressWarnings("unused") ForNode p_node) {}
  public void caseForNode(ForNode p_node)
  {
    inForNode(p_node);
    for (AbstractNode node : p_node.getSubNodes())
    {
      node.apply(this);
    }
    outForNode(p_node);
  }

  public void inAbstractPathNode(@SuppressWarnings("unused") AbstractPathNode p_node) {}
  public void outAbstractPathNode(@SuppressWarnings("unused") AbstractPathNode p_node) {}
  public void caseAbstractPathNode(AbstractPathNode p_node)
  {
    inAbstractPathNode(p_node);
    for (AbstractNode node : p_node.getPathElements())
    {
      node.apply(this);
    }
    outAbstractPathNode(p_node);
  }

  public void inImplementsNode(@SuppressWarnings("unused") ImplementsNode p_node) {}
  public void outImplementsNode(@SuppressWarnings("unused") ImplementsNode p_node) {}
  public void caseImplementsNode(ImplementsNode p_node)
  {
    inImplementsNode(p_node);
    for (AbstractNode node : p_node.getImplements())
    {
      node.apply(this);
    }
    outImplementsNode(p_node);
  }

  public void inImportNode(@SuppressWarnings("unused") ImportNode p_node) {}
  public void outImportNode(@SuppressWarnings("unused") ImportNode p_node) {}
  public void caseImportNode(ImportNode p_node)
  {
    inImportNode(p_node);
    outImportNode(p_node);
  }

  public void inAliasesNode(@SuppressWarnings("unused") AliasesNode p_node) {}
  public void outAliasesNode(@SuppressWarnings("unused") AliasesNode p_node) {}
  public void caseAliasesNode(AliasesNode p_node)
  {
    inAliasesNode(p_node);
    for (AbstractNode node : p_node.getAliass())
    {
      node.apply(this);
    }
    outAliasesNode(p_node);
  }

  public void inGenericCallParam(@SuppressWarnings("unused") GenericCallParam p_node) {}
  public void outGenericCallParam(@SuppressWarnings("unused") GenericCallParam p_node) {}
  public void caseGenericCallParam(GenericCallParam p_node)
  {
    inGenericCallParam(p_node);
    outGenericCallParam(p_node);
  }

  public void inChildCallNode(@SuppressWarnings("unused") ChildCallNode p_node) {}
  public void outChildCallNode(@SuppressWarnings("unused") ChildCallNode p_node) {}
  public void caseChildCallNode(ChildCallNode p_node)
  {
    inChildCallNode(p_node);
    outChildCallNode(p_node);
  }

  public void inNamedFragmentNode(@SuppressWarnings("unused") NamedFragmentNode p_node) {}
  public void outNamedFragmentNode(@SuppressWarnings("unused") NamedFragmentNode p_node) {}
  public void caseNamedFragmentNode(NamedFragmentNode p_node)
  {
    inNamedFragmentNode(p_node);
    for (AbstractNode node : p_node.getSubNodes())
    {
      node.apply(this);
    }
    outNamedFragmentNode(p_node);
  }

  public void inNamedParamNode(@SuppressWarnings("unused") NamedParamNode p_node) {}
  public void outNamedParamNode(@SuppressWarnings("unused") NamedParamNode p_node) {}
  public void caseNamedParamNode(NamedParamNode p_node)
  {
    inNamedParamNode(p_node);
    p_node.getName().apply(this);
    p_node.getValue().apply(this);
    outNamedParamNode(p_node);
  }

  public void inNamedAliasPathNode(@SuppressWarnings("unused") NamedAliasPathNode p_node) {}
  public void outNamedAliasPathNode(@SuppressWarnings("unused") NamedAliasPathNode p_node) {}
  public void caseNamedAliasPathNode(NamedAliasPathNode p_node)
  {
    inNamedAliasPathNode(p_node);
    for (AbstractNode node : p_node.getPathElements())
    {
      node.apply(this);
    }
    outNamedAliasPathNode(p_node);
  }

  public void inImplementNode(@SuppressWarnings("unused") ImplementNode p_node) {}
  public void outImplementNode(@SuppressWarnings("unused") ImplementNode p_node) {}
  public void caseImplementNode(ImplementNode p_node)
  {
    inImplementNode(p_node);
    outImplementNode(p_node);
  }

  public void inUnnamedParamsNode(@SuppressWarnings("unused") UnnamedParamsNode p_node) {}
  public void outUnnamedParamsNode(@SuppressWarnings("unused") UnnamedParamsNode p_node) {}
  public void caseUnnamedParamsNode(UnnamedParamsNode p_node)
  {
    inUnnamedParamsNode(p_node);
    for (AbstractNode node : p_node.getValues())
    {
      node.apply(this);
    }
    outUnnamedParamsNode(p_node);
  }

  public void inArgNode(@SuppressWarnings("unused") ArgNode p_node) {}
  public void outArgNode(@SuppressWarnings("unused") ArgNode p_node) {}
  public void caseArgNode(ArgNode p_node)
  {
    inArgNode(p_node);
    p_node.getType().apply(this);
    p_node.getName().apply(this);
    outArgNode(p_node);
  }

  public void inAbstractParamsNode(@SuppressWarnings("unused") AbstractParamsNode p_node) {}
  public void outAbstractParamsNode(@SuppressWarnings("unused") AbstractParamsNode p_node) {}
  public void caseAbstractParamsNode(AbstractParamsNode p_node)
  {
    inAbstractParamsNode(p_node);
    outAbstractParamsNode(p_node);
  }

  public void inAliasDefNode(@SuppressWarnings("unused") AliasDefNode p_node) {}
  public void outAliasDefNode(@SuppressWarnings("unused") AliasDefNode p_node) {}
  public void caseAliasDefNode(AliasDefNode p_node)
  {
    inAliasDefNode(p_node);
    p_node.getPath().apply(this);
    outAliasDefNode(p_node);
  }

  public void inAbsolutePathNode(@SuppressWarnings("unused") AbsolutePathNode p_node) {}
  public void outAbsolutePathNode(@SuppressWarnings("unused") AbsolutePathNode p_node) {}
  public void caseAbsolutePathNode(AbsolutePathNode p_node)
  {
    inAbsolutePathNode(p_node);
    for (AbstractNode node : p_node.getPathElements())
    {
      node.apply(this);
    }
    outAbsolutePathNode(p_node);
  }

  public void inStaticImportNode(@SuppressWarnings("unused") StaticImportNode p_node) {}
  public void outStaticImportNode(@SuppressWarnings("unused") StaticImportNode p_node) {}
  public void caseStaticImportNode(StaticImportNode p_node)
  {
    inStaticImportNode(p_node);
    outStaticImportNode(p_node);
  }

  public void inAbstractBodyNode(@SuppressWarnings("unused") AbstractBodyNode p_node) {}
  public void outAbstractBodyNode(@SuppressWarnings("unused") AbstractBodyNode p_node) {}
  public void caseAbstractBodyNode(AbstractBodyNode p_node)
  {
    inAbstractBodyNode(p_node);
    for (AbstractNode node : p_node.getSubNodes())
    {
      node.apply(this);
    }
    outAbstractBodyNode(p_node);
  }

  public void inAnnotationNode(@SuppressWarnings("unused") AnnotationNode p_node) {}
  public void outAnnotationNode(@SuppressWarnings("unused") AnnotationNode p_node) {}
  public void caseAnnotationNode(AnnotationNode p_node)
  {
    inAnnotationNode(p_node);
    outAnnotationNode(p_node);
  }

  public void inElseNode(@SuppressWarnings("unused") ElseNode p_node) {}
  public void outElseNode(@SuppressWarnings("unused") ElseNode p_node) {}
  public void caseElseNode(ElseNode p_node)
  {
    inElseNode(p_node);
    for (AbstractNode node : p_node.getSubNodes())
    {
      node.apply(this);
    }
    outElseNode(p_node);
  }

  public void inEscapeDirectiveNode(@SuppressWarnings("unused") EscapeDirectiveNode p_node) {}
  public void outEscapeDirectiveNode(@SuppressWarnings("unused") EscapeDirectiveNode p_node) {}
  public void caseEscapeDirectiveNode(EscapeDirectiveNode p_node)
  {
    inEscapeDirectiveNode(p_node);
    outEscapeDirectiveNode(p_node);
  }

  public void inFragmentArgsNode(@SuppressWarnings("unused") FragmentArgsNode p_node) {}
  public void outFragmentArgsNode(@SuppressWarnings("unused") FragmentArgsNode p_node) {}
  public void caseFragmentArgsNode(FragmentArgsNode p_node)
  {
    inFragmentArgsNode(p_node);
    for (AbstractNode node : p_node.getArgs())
    {
      node.apply(this);
    }
    outFragmentArgsNode(p_node);
  }

  public void inPathElementNode(@SuppressWarnings("unused") PathElementNode p_node) {}
  public void outPathElementNode(@SuppressWarnings("unused") PathElementNode p_node) {}
  public void casePathElementNode(PathElementNode p_node)
  {
    inPathElementNode(p_node);
    outPathElementNode(p_node);
  }

  public void inTextNode(@SuppressWarnings("unused") TextNode p_node) {}
  public void outTextNode(@SuppressWarnings("unused") TextNode p_node) {}
  public void caseTextNode(TextNode p_node)
  {
    inTextNode(p_node);
    outTextNode(p_node);
  }

  public void inUpdirNode(@SuppressWarnings("unused") UpdirNode p_node) {}
  public void outUpdirNode(@SuppressWarnings("unused") UpdirNode p_node) {}
  public void caseUpdirNode(UpdirNode p_node)
  {
    inUpdirNode(p_node);
    outUpdirNode(p_node);
  }

  public void inJavaNode(@SuppressWarnings("unused") JavaNode p_node) {}
  public void outJavaNode(@SuppressWarnings("unused") JavaNode p_node) {}
  public void caseJavaNode(JavaNode p_node)
  {
    inJavaNode(p_node);
    outJavaNode(p_node);
  }

  public void inDefaultEscapeNode(@SuppressWarnings("unused") DefaultEscapeNode p_node) {}
  public void outDefaultEscapeNode(@SuppressWarnings("unused") DefaultEscapeNode p_node) {}
  public void caseDefaultEscapeNode(DefaultEscapeNode p_node)
  {
    inDefaultEscapeNode(p_node);
    outDefaultEscapeNode(p_node);
  }

}
