package org.jamon.node;

import org.jamon.api.Location;
public class NamedAliasPathNode extends AbstractPathNode
{
  public NamedAliasPathNode(Location p_location, String p_alias)
  {
    super(p_location);
    if ((m_alias = p_alias) == null)
      { throw new NullPointerException(); }
  }

  @Override public void apply(Analysis p_analysis)
  {
    p_analysis.caseNamedAliasPathNode(this);
  }

  private final String m_alias;
  public String getAlias() { return m_alias; }

  @Override public boolean equals(Object p_obj)
  {
    return p_obj != null
        && super.equals(p_obj)
      && m_alias.equals(((NamedAliasPathNode) p_obj).m_alias)
    ;
  }

  @Override public int hashCode()
  {
    return super.hashCode()
      ^ m_alias.hashCode()
    ;
  }

  @Override protected void propertiesToString(StringBuilder p_buffer)
  {
    super.propertiesToString(p_buffer);
    addProperty(p_buffer, "alias", m_alias);
  }

}
