package org.jamon.node;

import org.jamon.api.Location;
public class OptionalArgNode extends ArgNode
{
  public OptionalArgNode(Location p_location, ArgTypeNode p_type, ArgNameNode p_name, ArgValueNode p_value)
  {
    super(p_location, p_type, p_name);
    if ((m_value = p_value) == null)
      { throw new NullPointerException(); }
  }

  @Override public void apply(Analysis p_analysis)
  {
    p_analysis.caseOptionalArgNode(this);
  }

  private final ArgValueNode m_value;
  public ArgValueNode getValue() { return m_value; }

  @Override public boolean equals(Object p_obj)
  {
    return p_obj != null
        && super.equals(p_obj)
      && m_value.equals(((OptionalArgNode) p_obj).m_value)
    ;
  }

  @Override public int hashCode()
  {
    return super.hashCode()
      ^ m_value.hashCode()
    ;
  }

  @Override protected void propertiesToString(StringBuilder p_buffer)
  {
    super.propertiesToString(p_buffer);
    addProperty(p_buffer, "value", m_value);
  }

}
