package org.jamon.node;

import org.jamon.api.Location;
public class TextNode extends AbstractNode
{
  public TextNode(Location p_location, String p_text)
  {
    super(p_location);
    if ((m_text = p_text) == null)
      { throw new NullPointerException(); }
  }

  @Override public void apply(Analysis p_analysis)
  {
    p_analysis.caseTextNode(this);
  }

  private final String m_text;
  public String getText() { return m_text; }

  @Override public boolean equals(Object p_obj)
  {
    return p_obj != null
        && super.equals(p_obj)
      && m_text.equals(((TextNode) p_obj).m_text)
    ;
  }

  @Override public int hashCode()
  {
    return super.hashCode()
      ^ m_text.hashCode()
    ;
  }

  @Override protected void propertiesToString(StringBuilder p_buffer)
  {
    super.propertiesToString(p_buffer);
    addProperty(p_buffer, "text", m_text);
  }

}
