package org.jamon.node;

import java.util.ArrayList;
import java.util.List;

import org.jamon.api.Location;
public class UnnamedParamsNode extends AbstractParamsNode
{
  public UnnamedParamsNode(Location p_location)
  {
    super(p_location);
  }

  @Override public void apply(Analysis p_analysis)
  {
    p_analysis.caseUnnamedParamsNode(this);
  }

  private final List<ParamValueNode> m_values = new ArrayList<ParamValueNode>();
  public UnnamedParamsNode addValue(ParamValueNode p_value)
  {
    if (p_value == null) { throw new NullPointerException(); }
    m_values.add(p_value);
    return this;
  }
  public List<ParamValueNode> getValues() { return m_values; }

  @Override public boolean equals(Object p_obj)
  {
    return p_obj != null
        && super.equals(p_obj)
      && m_values.equals(((UnnamedParamsNode) p_obj).m_values)
    ;
  }

  @Override public int hashCode()
  {
    return super.hashCode()
      ^ m_values.hashCode()
    ;
  }

  @Override protected void propertiesToString(StringBuilder p_buffer)
  {
    super.propertiesToString(p_buffer);
    addPropertyList(p_buffer, "value", m_values);
  }

}
